Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 859)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 861)
@@ -1372,317 +1451,352 @@
        IMPLICIT NONE
 
-       INTEGER ::  i, i_omp, j, k, tn
-       LOGICAL ::  degraded_l, degraded_s
-       REAL    ::  gu, gv, flux_d, diss_d, u_comp, v_comp, w_comp
+       INTEGER ::  i, i_omp, j, k, tn, k_ppp, k_pp, k_mm
+       REAL    ::  gu, gv, flux_d, diss_d, u_comp, v_comp, w_comp, div
        REAL, DIMENSION(nzb:nzt+1)  ::  flux_t, diss_t, flux_r, diss_r, flux_n, &
                                        diss_n
-                                       
-       degraded_l = .FALSE.  
-       degraded_s = .FALSE.
 
        gu = 2.0 * u_gtrans
        gv = 2.0 * v_gtrans
 
-              
-       IF ( boundary_flags(j,i) /= 0 )  THEN
-!       
-!--      Degrade the order for Dirichlet bc. at the outflow boundary
-         SELECT CASE ( boundary_flags(j,i) )
-         
-            CASE ( 1 )
-               DO  k = nzb_w_inner(j,i)+1, nzt
-                  u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu
-                  flux_r(k) = u_comp * (                                      &
-                              7.0 * ( w(k,j,i+1) + w(k,j,i)   )               &
-                            -       ( w(k,j,i+2) + w(k,j,i-1) ) ) * adv_mom_3
-                  diss_r(k) = -ABS( u_comp ) * (                              &
-                              3.0 * ( w(k,j,i+1) - w(k,j,i)   )               & 
-                            -       ( w(k,j,i+2) - w(k,j,i-1) ) ) * adv_mom_3  
-               ENDDO
-               
-            CASE ( 2 )
-               DO  k = nzb_w_inner(j,i)+1, nzt
-                  u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu
-                  flux_r(k) = u_comp * ( w(k,j,i+1) + w(k,j,i) ) * 0.25 
-                  diss_r(k) = diss_2nd( w(k,j,i+1), w(k,j,i+1), w(k,j,i),     &
-                                        w(k,j,i-1), w(k,j,i-2), u_comp,       &
-                                        0.25, ddx )
-               ENDDO
-               
-            CASE ( 3 )
-               DO  k = nzb_w_inner(j,i)+1, nzt
-                  v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
-                  flux_n(k) = v_comp * (                                      &
-                              7.0 * ( w(k,j+1,i) + w(k,j,i)   )               &
-                            -       ( w(k,j+2,i) + w(k,j-1,i) ) ) * adv_mom_3
-                  diss_n(k) = -ABS( v_comp ) * (                              &
-                              3.0 * ( w(k,j+1,i) - w(k,j,i)   )               & 
-                            -       ( w(k,j+2,i) - w(k,j-1,i) ) ) * adv_mom_3
-               ENDDO
-               
-            CASE ( 4 )
-               DO  k = nzb_w_inner(j,i)+1, nzt
-                  v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
-                  flux_n(k) = v_comp * ( w(k,j+1,i) + w(k,j,i) ) * 0.25 
-                  diss_n(k) = diss_2nd( w(k,j+1,i), w(k,j+1,i), w(k,j,i),     &
-                                        w(k,j-1,i), w(k,j-2,i), v_comp,       &
-                                        0.25, ddy )
-               ENDDO
-               
-            CASE ( 5 )
-               DO  k = nzb_w_inner(j,i)+1, nzt
-                  u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu 
-                  flux_r(k) = u_comp * (                                      &
-                              7.0 * ( w(k,j,i+1) + w(k,j,i)   )               &
-                            -       ( w(k,j,i+2) + w(k,j,i-1) ) ) * adv_mom_3
-                  diss_r(k) = - ABS( u_comp ) * (                             &
-                              3.0 * ( w(k,j,i+1) - w(k,j,i) )                 & 
-                            -       ( w(k,j,i+2) - w(k,j,i-1) ) ) * adv_mom_3
-               ENDDO
-               
-            CASE ( 6 )
-               DO  k = nzb_w_inner(j,i)+1, nzt
-!               
-!--               Compute leftside fluxes for the left boundary of PE domain
-                  u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu
-                  flux_r(k) = u_comp *(                                       &
-                              7.0 * ( w(k,j,i+1) + w(k,j,i)   )               &
-                            -       ( w(k,j,i+2) + w(k,j,i-1) ) )  * adv_mom_3
-                  diss_r(k) = - ABS( u_comp ) * (                             &
-                              3.0 * ( w(k,j,i+1) - w(k,j,i) )                 & 
-                            -       ( w(k,j,i+2) - w(k,j,i-1) ) ) * adv_mom_3
-                  
-                  u_comp        = u(k+1,j,i) + u(k,j,i) - gu
-                  flux_l_w(k,j,tn) = u_comp * ( w(k,j,i) + w(k,j,i-1) ) * 0.25
-                  diss_l_w(k,j,tn) = diss_2nd( w(k,j,i+2), w(k,j,i+1), w(k,j,i), &
-                                            w(k,j,i-1), w(k,j,i-1), u_comp,   &
-                                            0.25, ddx )
-               ENDDO
-               degraded_l = .TRUE.
-               
-            CASE ( 7 )
-               DO  k = nzb_w_inner(j,i)+1, nzt
-                  v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
-                  flux_n(k) = v_comp *(                                       &
-                              7.0 * ( w(k,j+1,i) + w(k,j,i)   )               &
-                            -       ( w(k,j+2,i) + w(k,j-1,i) ) ) * adv_mom_3
-                  diss_n(k) = - ABS( v_comp ) * (                             &
-                              3.0 * ( w(k,j+1,i) - w(k,j,i)   )               & 
-                            -       ( w(k,j+2,i) - w(k,j-1,i) ) ) * adv_mom_3
-                ENDDO
-                
-            CASE ( 8 )
-               DO  k = nzb_w_inner(j,i)+1, nzt
-                  v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
-                  flux_n(k) = v_comp * (                                      &
-                              7.0 * ( w(k,j+1,i) + w(k,j,i)   )               &
-                            -       ( w(k,j+2,i) + w(k,j-1,i) ) ) * adv_mom_3
-                  diss_n(k) = - ABS( v_comp ) * (                             &
-                              3.0 * ( w(k,j+1,i) - w(k,j,i) )                 & 
-                            -       ( w(k,j+2,i) - w(k,j-1,i) ) ) * adv_mom_3
-!                    
-!--              Compute southside fluxes for the south boundary of PE domain           
-                  v_comp      = v(k+1,j,i) + v(k,j,i) - gv
-                  flux_s_w(k,tn) = v_comp * ( w(k,j,i) + w(k,j-1,i) ) * 0.25
-                  diss_s_w(k,tn) = diss_2nd( w(k,j+2,i), w(k,j+1,i), w(k,j,i),   &
-                                          w(k,j-1,i), w(k,j-1,i), v_comp,     &
-                                          0.25, ddy )                 
-               ENDDO  
-               degraded_s = .TRUE.
-               
-            CASE DEFAULT
-            
-         END SELECT
-!         
-!--      Compute the crosswise 5th order fluxes at the outflow
-         IF ( boundary_flags(j,i) == 1 .OR. boundary_flags(j,i) == 2  .OR.    &
-              boundary_flags(j,i) == 5 .OR. boundary_flags(j,i) == 6 )  THEN
-         
-            DO  k = nzb_w_inner(j,i)+1, nzt
-               v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
-               flux_n(k) = v_comp * (                                         &
-                           37.0 * ( w(k,j+1,i) + w(k,j,i)   )                 &
-                         -  8.0 * ( w(k,j+2,i) + w(k,j-1,i) )                 &
-                         +        ( w(k,j+3,i) + w(k,j-2,i) ) ) * adv_mom_5
-               diss_n(k) = - ABS( v_comp ) * (                                &
-                           10.0 * ( w(k,j+1,i) - w(k,j,i)   )                 &
-                         -  5.0 * ( w(k,j+2,i) - w(k,j-1,i) )                 &
-                         +        ( w(k,j+3,i) - w(k,j-2,i) ) ) * adv_mom_5
-            ENDDO
-            
-         ELSE
-         
-            DO  k = nzb_w_inner(j,i)+1, nzt         
-               u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu
-               flux_r(k) = u_comp * (                                         &
-                           37.0 * ( w(k,j,i+1) + w(k,j,i) )                   &
-                         -  8.0 * ( w(k,j,i+2) + w(k,j,i-1) )                 &
-                         +        ( w(k,j,i+3) + w(k,j,i-2) ) ) * adv_mom_5
-               diss_r(k) = - ABS( u_comp ) * (                                &
-                           10.0 * ( w(k,j,i+1) - w(k,j,i)   )                 &
-                         -  5.0 * ( w(k,j,i+2) - w(k,j,i-1) )                 &
-                         +        ( w(k,j,i+3) - w(k,j,i-2) ) ) * adv_mom_5
-            ENDDO
-            
-         ENDIF
-         
-       ELSE
-!       
-!--      Compute the fifth order fluxes for the interior of PE domain.               
-         DO  k = nzb_w_inner(j,i)+1, nzt
-            u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu
-            flux_r(k) = u_comp * (                                            &
-                        37.0 * ( w(k,j,i+1) + w(k,j,i)   )                    &
-                      -  8.0 * ( w(k,j,i+2) + w(k,j,i-1) )                    &
-                      +        ( w(k,j,i+3) + w(k,j,i-2) ) ) * adv_mom_5
-            diss_r(k) = - ABS( u_comp ) * (                                   &
-                        10.0 * ( w(k,j,i+1) - w(k,j,i)   )                    &
-                      -  5.0 * ( w(k,j,i+2) - w(k,j,i-1) )                    &
-                      +        ( w(k,j,i+3) - w(k,j,i-2) ) ) * adv_mom_5
-                 
-            v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
-            flux_n(k) = v_comp * (                                            &
-                        37.0 * ( w(k,j+1,i) + w(k,j,i)   )                    &
-                      -  8.0 * ( w(k,j+2,i) + w(k,j-1,i) )                    &
-                      +        ( w(k,j+3,i) + w(k,j-2,i) ) ) * adv_mom_5
-            diss_n(k) = - ABS( v_comp ) * (                                   &
-                        10.0 * ( w(k,j+1,i) - w(k,j,i)   )                    &
-                      -  5.0 * ( w(k,j+2,i) - w(k,j-1,i) )                    &
-                      +        ( w(k,j+3,i) - w(k,j-2,i) ) ) * adv_mom_5
-         ENDDO 
-         
-       ENDIF
-!       
-!--    Compute left- and southside fluxes for the respective boundary      
-       IF ( j == nys  .AND.  .NOT. degraded_s )  THEN
-       
-          DO  k = nzb_w_inner(j,i)+1, nzt
+!
+!--    Compute southside fluxes for the respective boundary.
+       IF ( j == nys )  THEN
+
+          DO  k = nzb+1, nzb_max
+
              v_comp      = v(k+1,j,i) + v(k,j,i) - gv
-             flux_s_w(k,tn) = v_comp * (                                         &
+             flux_s_w(k,tn) = v_comp * (                                      &
+                         ( 37.0 * IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5 &
+                      +     7.0 * IBITS(wall_flags_0(k,j,i),31,1) * adv_mom_3 &
+                      +           IBITS(wall_flags_0(k,j,i),30,1) * adv_mom_1 &
+                         ) *                                                  &
+                                     ( w(k,j,i)   + w(k,j-1,i) )              &
+                  -      (  8.0 * IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5 &
+                      +           IBITS(wall_flags_0(k,j,i),31,1) * adv_mom_3 &
+                         ) *                                                  &
+                                     ( w(k,j+1,i) + w(k,j-2,i) )              &
+                  +      (        IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5 &
+                         ) *                                                  &
+                                     ( w(k,j+2,i) + w(k,j-3,i) )              &
+                                         )
+
+             diss_s_w(k,tn) = - ABS( v_comp ) * (                             &
+                         ( 10.0 * IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5 &
+                      +     3.0 * IBITS(wall_flags_0(k,j,i),31,1) * adv_mom_3 &
+                      +           IBITS(wall_flags_0(k,j,i),30,1) * adv_mom_1 &
+                         ) *                                                  &
+                                     ( w(k,j,i)   - w(k,j-1,i) )              &
+                  -      (  5.0 * IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5 &
+                      +           IBITS(wall_flags_0(k,j,i),31,1) * adv_mom_3 &
+                         ) *                                                  &
+                                     ( w(k,j+1,i) - w(k,j-2,i) )              &
+                  +      (        IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5 &
+                         ) *                                                  &
+                                     ( w(k,j+2,i) - w(k,j-3,i) )              &
+                                                 )
+
+          ENDDO
+
+          DO  k = nzb_max+1, nzt
+
+             v_comp         = v(k+1,j,i) + v(k,j,i) - gv
+             flux_s_w(k,tn) = v_comp * (                                      &
                            37.0 * ( w(k,j,i) + w(k,j-1,i)   )                 &
                          -  8.0 * ( w(k,j+1,i) +w(k,j-2,i)  )                 &
                          +        ( w(k,j+2,i) + w(k,j-3,i) ) ) * adv_mom_5
-             diss_s_w(k,tn) = - ABS( v_comp ) * (                                &
+             diss_s_w(k,tn) = - ABS( v_comp ) * (                             &
                            10.0 * ( w(k,j,i) - w(k,j-1,i)   )                 &
                          -  5.0 * ( w(k,j+1,i) - w(k,j-2,i) )                 &
                          +        ( w(k,j+2,i) - w(k,j-3,i) ) ) * adv_mom_5
-          ENDDO
-          
+
+          ENDDO
+
        ENDIF
-       
-       IF ( i == i_omp  .AND.   .NOT. degraded_l ) THEN
-          
-          DO  k = nzb_w_inner(j,i)+1, nzt
-            u_comp        = u(k+1,j,i) + u(k,j,i) - gu
-            flux_l_w(k,j,tn) = u_comp * (                                        &
+!
+!--    Compute leftside fluxes for the respective boundary.
+       IF ( i == i_omp ) THEN
+
+          DO  k = nzb+1, nzb_max
+
+             u_comp         = u(k+1,j,i) + u(k,j,i) - gu
+             flux_l_w(k,j,tn) = u_comp * (                                     &
+                          ( 37.0 * IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5 &
+                       +     7.0 * IBITS(wall_flags_0(k,j,i),28,1) * adv_mom_3 &
+                       +           IBITS(wall_flags_0(k,j,i),27,1) * adv_mom_1 &
+                          ) *                                                  &
+                                     ( w(k,j,i)   + w(k,j,i-1) )               &
+                   -      (  8.0 * IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5 &
+                       +           IBITS(wall_flags_0(k,j,i),28,1) * adv_mom_3 &
+                          ) *                                                  &
+                                     ( w(k,j,i+1) + w(k,j,i-2) )               &
+                   +      (        IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5 &
+                          ) *                                                  &
+                                     ( w(k,j,i+2) + w(k,j,i-3) )               &
+                                         )
+
+               diss_l_w(k,j,tn) = - ABS( u_comp ) * (                          &
+                          ( 10.0 * IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5 &
+                       +     3.0 * IBITS(wall_flags_0(k,j,i),28,1) * adv_mom_3 &
+                       +           IBITS(wall_flags_0(k,j,i),27,1) * adv_mom_1 &
+                          ) *                                                  &
+                                     ( w(k,j,i)   - w(k,j,i-1) )               &
+                   -      (  5.0 * IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5 &
+                       +           IBITS(wall_flags_0(k,j,i),28,1) * adv_mom_3 &
+                          ) *                                                  &
+                                     ( w(k,j,i+1) - w(k,j,i-2) )               &
+                   +      (        IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5 &
+                          ) *                                                  &
+                                     ( w(k,j,i+2) - w(k,j,i-3) )               &
+                                                    )
+
+          ENDDO
+
+          DO  k = nzb_max+1, nzt
+
+             u_comp           = u(k+1,j,i) + u(k,j,i) - gu
+             flux_l_w(k,j,tn) = u_comp * (                                    &
                             37.0 * ( w(k,j,i) + w(k,j,i-1)   )                &
                           -  8.0 * ( w(k,j,i+1) + w(k,j,i-2) )                &
                           +        ( w(k,j,i+2) + w(k,j,i-3) ) ) * adv_mom_5
-            diss_l_w(k,j,tn) = - ABS( u_comp ) * (                               &
+             diss_l_w(k,j,tn) = - ABS( u_comp ) * (                           &
                             10.0 * ( w(k,j,i) - w(k,j,i-1)   )                &
                           -  5.0 * ( w(k,j,i+1) - w(k,j,i-2) )                &
                           +        ( w(k,j,i+2) - w(k,j,i-3) ) ) * adv_mom_5 
-          ENDDO
-          
+
+          ENDDO
+
        ENDIF
 
-!       
-!--    Now compute the tendency terms for the horizontal parts.         
-       DO  k = nzb_w_inner(j,i)+1, nzt
+       flux_t(0) = 0.0
+       diss_t(0) = 0.0
+       flux_d    = 0.0
+       diss_d    = 0.0
+!
+!--    Now compute the fluxes and tendency terms for the horizontal
+!--    and vertical parts.
+       DO  k = nzb+1, nzb_max
+
+          u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu
+          flux_r(k) = u_comp * (                                             &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),28,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),27,1) * adv_mom_1    &
+                     ) *                                                     &
+                                 ( w(k,j,i+1) + w(k,j,i)   )                 &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),28,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( w(k,j,i+2) + w(k,j,i-1) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( w(k,j,i+3) + w(k,j,i-2) )                 &
+                               )
+
+          diss_r(k) = - ABS( u_comp ) * (                                    &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),28,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),27,1) * adv_mom_1    &
+                     ) *                                                     &
+                                 ( w(k,j,i+1) - w(k,j,i)  )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),28,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( w(k,j,i+2) - w(k,j,i-1) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( w(k,j,i+3) - w(k,j,i-2) )                 &
+                                        )
+
+          v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
+          flux_n(k) = v_comp * (                                             &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),31,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),30,1) * adv_mom_1    &
+                     ) *                                                     &
+                                 ( w(k,j+1,i) + w(k,j,i)   )                 &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),31,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( w(k,j+2,i) + w(k,j-1,i) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( w(k,j+3,i) + w(k,j-2,i) )                 &
+                               )
+
+          diss_n(k) = - ABS( v_comp ) * (                                    &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),31,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),30,1) * adv_mom_1    &
+                     ) *                                                     &
+                                 ( w(k,j+1,i) - w(k,j,i)  )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),31,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( w(k,j+2,i) - w(k,j-1,i) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( w(k,j+3,i) - w(k,j-2,i) )                 &
+                                        )
+!
+!--       k index has to be modified near bottom and top, else array
+!--       subscripts will be exceeded.
+          k_ppp = k + 3 * IBITS(wall_flags_0(k,j,i),35,1)
+          k_pp  = k + 2 * ( 1 - IBITS(wall_flags_0(k,j,i),33,1)  )
+          k_mm  = k - 2 * IBITS(wall_flags_0(k,j,i),35,1)
+
+          w_comp    = w(k+1,j,i) + w(k,j,i)
+          flux_t(k) = w_comp  * (                                            &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),34,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),33,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( w(k+1,j,i)  + w(k,j,i)     )                  &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),34,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( w(k_pp,j,i)  + w(k-1,j,i)  )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( w(k_ppp,j,i) + w(k_mm,j,i) )                  &
+                                 )
+
+          diss_t(k) = - ABS( w_comp ) * (                                    &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),34,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),33,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( w(k+1,j,i)   - w(k,j,i)    )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),34,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( w(k_pp,j,i)  - w(k-1,j,i)  )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( w(k_ppp,j,i) - w(k_mm,j,i) )                  &
+                                         )
+!
+!--       Calculate the divergence of the velocity field. A respective
+!--       correction is needed to overcome numerical instabilities introduced
+!--       by a not sufficient reduction of divergences near topography. 
+          div = ( ( u_comp + gu - ( u(k+1,j,i) + u(k,j,i)   ) ) * ddx         &
+              +   ( v_comp + gv - ( v(k+1,j,i) + v(k,j,i)   ) ) * ddy         &
+              +   ( w_comp      - ( w(k,j,i)   + w(k-1,j,i) ) ) * ddzu(k+1)   &
+                ) * 0.5
+
           tend(k,j,i) = tend(k,j,i) - (                                       &
                       ( flux_r(k) + diss_r(k)                                 &
-                    -   flux_l_w(k,j,tn) - diss_l_w(k,j,tn)   ) * ddx               &
+                    -   flux_l_w(k,j,tn) - diss_l_w(k,j,tn)   ) * ddx         &
                     + ( flux_n(k) + diss_n(k)                                 &
-                    -   flux_s_w(k,tn) - diss_s_w(k,tn)       ) * ddy  )
+                    -   flux_s_w(k,tn) - diss_s_w(k,tn)       ) * ddy         &
+                    + ( flux_t(k) + diss_t(k)                                 &
+                    -   flux_d    - diss_d                    ) * ddzu(k+1)   &
+                                      ) + div * w(k,j,i)
 
           flux_l_w(k,j,tn) = flux_r(k)
           diss_l_w(k,j,tn) = diss_r(k)
-          flux_s_w(k,tn) = flux_n(k)
-          diss_s_w(k,tn) = diss_n(k)
+          flux_s_w(k,tn)   = flux_n(k)
+          diss_s_w(k,tn)   = diss_n(k)
+          flux_d           = flux_t(k)
+          diss_d           = diss_t(k)
+!
+!--        Statistical Evaluation of w'w'.
+          sums_ws2_ws_l(k,tn)  = sums_ws2_ws_l(k,tn)                         &
+                             + ( flux_t(k) + diss_t(k) )                     &
+                             *   weight_substep(intermediate_timestep_count)
+
        ENDDO
 
-!
-!--    Vertical advection, degradation of order near surface and top. 
-!--    The fluxes flux_d and diss_d at the surface are 0. Due to reasons of
-!--    statistical evaluation the top flux at the surface should be 0
-       flux_t(nzb_w_inner(j,i)) = 0.0  !statistical reasons
-       diss_t(nzb_w_inner(j,i)) = 0.0
-!
-!--    2nd order scheme (bottom)       
-       k         = nzb_w_inner(j,i)+1
-       flux_d    = flux_t(k-1)
-       diss_d    = diss_t(k-1)
-       w_comp    = w(k+1,j,i) + w(k,j,i)
-       flux_t(k) = w_comp * ( w(k+1,j,i) + w(k,j,i) ) * 0.25
-       diss_t(k) = diss_2nd( w(k+2,j,i), w(k+1,j,i), w(k,j,i), 0.0, 0.0,        &
-                             w_comp, 0.25, ddzu(k+1) )
-                      
-       tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)                    &
-                                 -   flux_d    - diss_d      ) * ddzu(k+1)               
-!
-!--    WS3 as an intermediate step (bottom)
-       k         = nzb_w_inner(j,i)+2
-       flux_d    = flux_t(k-1)
-       diss_d    = diss_t(k-1)
-       w_comp    = w(k+1,j,i) + w(k,j,i)
-       flux_t(k) = w_comp * (                                                 &
-                   7.0 * ( w(k+1,j,i) + w(k,j,i) )                            &
-                 -       ( w(k+2,j,i) + w(k-1,j,i) ) ) * adv_mom_3
-       diss_t(k) = - ABS( w_comp ) * (                                        &
-                   3.0 * ( w(k+1,j,i) - w(k,j,i) )                            & 
-                 -       ( w(k+2,j,i) - w(k-1,j,i) ) ) * adv_mom_3
-
-       tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)                    &
-                                 -   flux_d    - diss_d      ) * ddzu(k+1)
-!                                 
-!--    WS5
-       DO  k = nzb_w_inner(j,i)+3, nzt-2 
-          flux_d    = flux_t(k-1)
-          diss_d    = diss_t(k-1)
+       DO  k = nzb_max+1, nzt
+
+          u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu
+          flux_r(k) = u_comp * (                                            &
+                      37.0 * ( w(k,j,i+1) + w(k,j,i)   )                    &
+                    -  8.0 * ( w(k,j,i+2) + w(k,j,i-1) )                    &
+                    +        ( w(k,j,i+3) + w(k,j,i-2) ) ) * adv_mom_5
+
+          diss_r(k) = - ABS( u_comp ) * (                                   &
+                      10.0 * ( w(k,j,i+1) - w(k,j,i)   )                    &
+                    -  5.0 * ( w(k,j,i+2) - w(k,j,i-1) )                    &
+                    +        ( w(k,j,i+3) - w(k,j,i-2) ) ) * adv_mom_5
+
+          v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
+          flux_n(k) = v_comp * (                                            &
+                      37.0 * ( w(k,j+1,i) + w(k,j,i)   )                    &
+                    -  8.0 * ( w(k,j+2,i) + w(k,j-1,i) )                    &
+                    +        ( w(k,j+3,i) + w(k,j-2,i) ) ) * adv_mom_5
+
+          diss_n(k) = - ABS( v_comp ) * (                                   &
+                      10.0 * ( w(k,j+1,i) - w(k,j,i)   )                    &
+                    -  5.0 * ( w(k,j+2,i) - w(k,j-1,i) )                    &
+                    +        ( w(k,j+3,i) - w(k,j-2,i) ) ) * adv_mom_5
+!
+!--       k index has to be modified near bottom and top, else array
+!--       subscripts will be exceeded.
+          k_ppp = k + 3 * IBITS(wall_flags_0(k,j,i),35,1)
+          k_pp  = k + 2 * ( 1 - IBITS(wall_flags_0(k,j,i),33,1)  )
+          k_mm  = k - 2 * IBITS(wall_flags_0(k,j,i),35,1)
+
           w_comp    = w(k+1,j,i) + w(k,j,i)
-          flux_t(k) = w_comp * (                                              &
-                      37.0 * ( w(k+1,j,i) + w(k,j,i)   )                      &
-                    -  8.0 * ( w(k+2,j,i) + w(k-1,j,i) )                      &
-                    +        ( w(k+3,j,i) + w(k-2,j,i) ) ) * adv_mom_5
-          diss_t(k) = - ABS( w_comp ) * (                                     &
-                      10.0 * ( w(k+1,j,i) - w(k,j,i)   )                      & 
-                    -  5.0 * ( w(k+2,j,i) - w(k-1,j,i) )                      & 
-                    +        ( w(k+3,j,i) - w(k-2,j,i) ) ) * adv_mom_5
-
-          tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)                 &
-                                    -   flux_d    - diss_d      ) * ddzu(k+1)
+          flux_t(k) = w_comp  * (                                            &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),34,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),33,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( w(k+1,j,i)  + w(k,j,i)     )                  &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),34,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( w(k_pp,j,i)  + w(k-1,j,i)  )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( w(k_ppp,j,i) + w(k_mm,j,i) )                  &
+                                 )
+
+          diss_t(k) = - ABS( w_comp ) * (                                    &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),34,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),33,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( w(k+1,j,i)   - w(k,j,i)    )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),34,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( w(k_pp,j,i)  - w(k-1,j,i)  )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( w(k_ppp,j,i) - w(k_mm,j,i) )                  &
+                                         )
+!
+!--       Calculate the divergence of the velocity field. A respective
+!--       correction is needed to overcome numerical instabilities introduced
+!--       by a not sufficient reduction of divergences near topography.
+          div = ( ( u_comp + gu - ( u(k+1,j,i) + u(k,j,i)   ) ) * ddx         &
+              +   ( v_comp + gv - ( v(k+1,j,i) + v(k,j,i)   ) ) * ddy         &
+              +   ( w_comp      - ( w(k,j,i)   + w(k-1,j,i) ) ) * ddzu(k+1)   &
+                ) * 0.5
+
+          tend(k,j,i) = tend(k,j,i) - (                                       &
+                      ( flux_r(k) + diss_r(k)                                 &
+                    -   flux_l_w(k,j,tn) - diss_l_w(k,j,tn)   ) * ddx         &
+                    + ( flux_n(k) + diss_n(k)                                 &
+                    -   flux_s_w(k,tn) - diss_s_w(k,tn)       ) * ddy         &
+                    + ( flux_t(k) + diss_t(k)                                 &
+                    -   flux_d    - diss_d                    ) * ddzu(k+1)   &
+                                      ) + div * w(k,j,i)
+
+          flux_l_w(k,j,tn) = flux_r(k)
+          diss_l_w(k,j,tn) = diss_r(k)
+          flux_s_w(k,tn)   = flux_n(k)
+          diss_s_w(k,tn)   = diss_n(k)
+          flux_d           = flux_t(k)
+          diss_d           = diss_t(k)
+!
+!--        Statistical Evaluation of w'w'.
+          sums_ws2_ws_l(k,tn)  = sums_ws2_ws_l(k,tn)                         &
+                             + ( flux_t(k) + diss_t(k) )                     &
+                             *   weight_substep(intermediate_timestep_count)
+
        ENDDO
-!--    WS3 as an intermediate step (top)
-       k         = nzt - 1
-       flux_d    = flux_t(k-1)
-       diss_d    = diss_t(k-1)
-       w_comp    = w(k+1,j,i) + w(k,j,i)
-       flux_t(k) = w_comp * (                                                 &
-                   7.0 * ( w(k+1,j,i) + w(k,j,i)   )                          &
-                 -       ( w(k+2,j,i) + w(k-1,j,i) ) ) *adv_mom_3
-       diss_t(k) = - ABS( w_comp ) * (                                        &
-                   3.0 * ( w(k+1,j,i) - w(k,j,i)     )                        & 
-                 -       ( w(k+2,j,i) - w(k-1,j,i) ) ) * adv_mom_3
-                   
-       tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)                    &
-                                 -   flux_d    - diss_d      ) * ddzu(k+1)
-!
-!--    2nd order scheme (top)
-       k         = nzt
-       flux_d    = flux_t(k-1)
-       diss_d    = diss_t(k-1)
-       w_comp    = w(k+1,j,i) + w(k,j,i)
-       flux_t(k) = w_comp * ( w(k+1,j,i) + w(k,j,i) ) * 0.25
-       diss_t(k) = diss_2nd( w(k+1,j,i), w(k+1,j,i), w(k,j,i), w(k-1,j,i),    &
-                             w(k-2,j,i), w_comp, 0.25, ddzu(k+1) )
-
-       tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)                    &
-                                 -   flux_d    - diss_d      ) * ddzu(k+1)
-       
-       DO  k = nzb_w_inner(j,i), nzt
-           sums_ws2_ws_l(k,tn)  = sums_ws2_ws_l(k,tn)                               &
-                 + ( flux_t(k) + diss_t(k) )                                  &
-                 *   weight_substep(intermediate_timestep_count)
-       ENDDO
+
 
     END SUBROUTINE advec_w_ws_ij
